#!/usr/bin/env python
# -*- coding: utf-8 -*-


class ObjectClasses:
    Pedestrian = "pedestrian"
    Bicycle = "bicycle"
    Motorbike = "motorbike"
    Car = "car"
    Bus = "bus"
    Truck = "truck"
    Dog = "dog"
    Kickboard = "kickboard"
    Van = "van"
    Stroller = "stroller"
    Standard = [Pedestrian, Bicycle, Motorbike, Car, Bus, Truck, Van]
    All = [
        Pedestrian,
        Bicycle,
        Motorbike,
        Car,
        Bus,
        Truck,
        Dog,
        Kickboard,
        Van,
        Stroller,
    ]


class ObjectClassesPlural:
    Pedestrians = "pedestrians"
    Bicycles = "bicycles"
    Motorbikes = "motorbikes"
    Cars = "cars"
    Buses = "buses"
    Trucks = "trucks"
    Dogs = "dogs"
    Kickboards = "kickboards"
    Vans = "vans"
    Strollers = "strollers"


OBJECT_CLASS_PLURALIZATION_MAP = {
    ObjectClasses.Pedestrian: ObjectClassesPlural.Pedestrians,
    ObjectClasses.Bicycle: ObjectClassesPlural.Bicycles,
    ObjectClasses.Motorbike: ObjectClassesPlural.Motorbikes,
    ObjectClasses.Car: ObjectClassesPlural.Cars,
    ObjectClasses.Bus: ObjectClassesPlural.Buses,
    ObjectClasses.Truck: ObjectClassesPlural.Trucks,
    ObjectClasses.Dog: ObjectClassesPlural.Dogs,
    ObjectClasses.Kickboard: ObjectClassesPlural.Kickboards,
    ObjectClasses.Van: ObjectClassesPlural.Vans,
    ObjectClasses.Stroller: ObjectClassesPlural.Strollers,
}


class ObjectClassesColorDefinitions:
    Pedestrian = "#2FBA78"
    Bicycle = "#0FA7F0"
    Motorbike = "#FF66FF"
    Car = "#FA684D"
    Bus = "#863CF6"
    Truck = "#D1232F"
    Dog = "#2D719F"
    Kickboard = "#F7B32B"
    Van = "#8C5516"
    Stroller = "#157106"  # Stroller is not yet present in the dashboard, so this color is just a placeholder for internal use


ALL_OBJECT_CLASSES = [
    ObjectClasses.Pedestrian,
    ObjectClasses.Bicycle,
    ObjectClasses.Motorbike,
    ObjectClasses.Car,
    ObjectClasses.Bus,
    ObjectClasses.Truck,
    ObjectClasses.Dog,
    ObjectClasses.Kickboard,
    ObjectClasses.Van,
    ObjectClasses.Stroller,
]


OBJECT_CLASSES_COLOR_MAP = {
    obj_class: getattr(ObjectClassesColorDefinitions, obj_class.capitalize())
    for obj_class in ALL_OBJECT_CLASSES
}


class CommonIntervals:
    # https://github.com/numina/numina-graph/blob/1fbd20f0a55077621d1d95b7da21a054167b51ae/api/src/analytics_queries/athena_filters.py#L174
    FifteenMinutes = "15m"
    ThirtyMinutes = "30m"
    OneHour = "1h"
    ThreeHours = "3h"
    SixHours = "6h"
    TwelveHours = "12h"
    OneDay = "1d"
    OneWeek = "1w"
    OneMinute = "1m"


class DataVersions:
    JUNE_2023 = "JUNE_2023"
    JULY_2022 = "JULY_2022"


ATHENA_STAGING_BUCKET = "s3://autogenerated-athena-api-query-results/"
NUMINA_GRAPH_URL = "https://api.numina.co/graphql"
SAMPLE_IMAGE_BUCKET = "numina-sensor-background-images"
